From 3797cb51563a114e1e53735eb6b6b838502f2913 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Mon, 3 Feb 2020 03:49:52 +0300
Subject: [PATCH 07/59] kath helper: add and implement update() and upgrade()
 actions

---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp  | 97 +++++++++++++++++++
 .../AlpineApkBackend/AlpineApkAuthHelper.h    |  9 ++
 .../org.kde.discover.alpineapkbackend.actions | 24 +++++
 3 files changed, 130 insertions(+)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index 19236dcb3..4ff5c880a 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -20,14 +20,22 @@
 
 #include <QProcess>
 #include <QDebug>
+#include <QLoggingCategory>
 #include <QJsonDocument>
 #include <QJsonObject>
 #include <QJsonArray>
 #include <QFile>
+
 #include <KAuthHelperSupport>
 
 #include "AlpineApkAuthHelper.h"
 
+#ifdef QT_DEBUG
+Q_LOGGING_CATEGORY(LOG_AUTHHELPER, "org.kde.discover.alpineapkbackend.authhelper", QtDebugMsg)
+#else
+Q_LOGGING_CATEGORY(LOG_AUTHHELPER, "org.kde.discover.alpineapkbackend.authhelper", QtWarningMsg)
+#endif
+
 using namespace KAuth;
 
 AlpineApkAuthHelper::AlpineApkAuthHelper() {}
@@ -39,6 +47,7 @@ ActionReply AlpineApkAuthHelper::test(const QVariantMap &args)
     ActionReply reply = ActionReply::HelperErrorReply();
     QByteArray replyData(QByteArrayLiteral("ok"));
 
+    // write some text file at the root directory as root, why not
     QFile f(QStringLiteral("/lol.txt"));
     if (f.open(QIODevice::ReadWrite | QIODevice::Text)) {
         f.write(txt.toUtf8());
@@ -53,4 +62,92 @@ ActionReply AlpineApkAuthHelper::test(const QVariantMap &args)
     return reply;
 }
 
+ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
+{
+    Q_UNUSED(args)
+    ActionReply reply = ActionReply::HelperErrorReply();
+
+    HelperSupport::progressStep(10);
+
+    if (!m_apkdb.open(QtApk::Database::QTAPK_OPENF_READWRITE)) {
+        reply.setErrorDescription(QStringLiteral("Failed to open database!"));
+        return reply;
+    }
+
+    bool update_ok = m_apkdb.updatePackageIndex();
+
+    if (update_ok) {
+        int updatesCount = m_apkdb.upgradeablePackagesCount();
+        reply = ActionReply::SuccessReply();
+        reply.setData({
+            { QLatin1String("updatesCount"), updatesCount }
+        });
+    } else {
+        reply.setErrorDescription(QStringLiteral("Repo update failed!"));
+        reply.setData({
+            { QLatin1String("errorString"), QStringLiteral("Repo update failed!") }
+        });
+    }
+
+    m_apkdb.close();
+    HelperSupport::progressStep(100);
+
+    return reply;
+}
+
+ActionReply AlpineApkAuthHelper::add(const QVariantMap &args)
+{
+    ActionReply reply = ActionReply::HelperErrorReply();
+    return reply;
+}
+
+ActionReply AlpineApkAuthHelper::del(const QVariantMap &args)
+{
+    ActionReply reply = ActionReply::HelperErrorReply();
+    return reply;
+}
+
+ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
+{
+    ActionReply reply = ActionReply::HelperErrorReply();
+
+    HelperSupport::progressStep(10);
+
+    if (!m_apkdb.open(QtApk::Database::QTAPK_OPENF_READWRITE)) {
+        reply.setErrorDescription(QStringLiteral("Failed to open database!"));
+        return reply;
+    }
+
+    bool onlySimulate = args.value(QLatin1String("onlySimulate"), false).toBool();
+    QtApk::Database::DbUpgradeFlags flags = QtApk::Database::QTAPK_UPGRADE_DEFAULT;
+    if (onlySimulate) {
+        flags = QtApk::Database::QTAPK_UPGRADE_SIMULATE;
+        qCDebug(LOG_AUTHHELPER) << "Simulating upgrade run.";
+    }
+
+    QtApk::Changeset changes;
+    bool upgrade_ok = m_apkdb.upgrade(flags, &changes);
+
+    if (upgrade_ok) {
+        reply = ActionReply::SuccessReply();
+        QVariantMap replyData;
+        const QVector<QtApk::ChangesetItem> ch = changes.changes();
+        QVector<QVariant> chVector;
+        QVector<QtApk::Package> pkgVector;
+        for (const QtApk::ChangesetItem &it: ch) {
+            pkgVector << it.newPackage;
+        }
+        replyData.insert(QLatin1String("changes"), QVariant::fromValue(pkgVector));
+        replyData.insert(QLatin1String("onlySimulate"), onlySimulate);
+        reply.setData(replyData);
+    } else {
+        reply.setErrorDescription(QStringLiteral("Repo upgrade failed!"));
+    }
+
+    m_apkdb.close();
+    HelperSupport::progressStep(100);
+
+    return reply;
+}
+
 KAUTH_HELPER_MAIN("org.kde.discover.alpineapkbackend", AlpineApkAuthHelper)
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index 947dcb7ac..5c06e5570 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -22,6 +22,8 @@
 #include <QVariant>
 #include <KAuthActionReply>
 
+#include <QtApk.h>
+
 using namespace KAuth;
 
 class AlpineApkAuthHelper : public QObject
@@ -32,4 +34,11 @@ public:
 
 public Q_SLOTS:
     ActionReply test(const QVariantMap &args);
+    ActionReply update(const QVariantMap &args);
+    ActionReply add(const QVariantMap &args);
+    ActionReply del(const QVariantMap &args);
+    ActionReply upgrade(const QVariantMap &args);
+
+private:
+    QtApk::Database m_apkdb;
 };
diff --git a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
index 3b9a3116e..10305a1af 100644
--- a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
+++ b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
@@ -3,3 +3,27 @@ Name=Test Action
 Description=Just test
 Policy=auth_admin
 Persistence=session
+
+[org.kde.discover.alpineapkbackend.update]
+Name=Update repository index
+Description=Updates available packages list from repositories
+Policy=auth_admin
+Persistence=session
+
+[org.kde.discover.alpineapkbackend.upgrade]
+Name=Upgrade all upgradable packages
+Description=Upgrade installed packages to latest versions
+Policy=auth_admin
+Persistence=session
+
+[org.kde.discover.alpineapkbackend.add]
+Name=Install/upgrade package
+Description=Installs/upgrades one package
+Policy=auth_admin
+Persistence=session
+
+[org.kde.discover.alpineapkbackend.del]
+Name=Remove package
+Description=Uninstall one package
+Policy=auth_admin
+Persistence=session
-- 
GitLab


